(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("email-validator"), require("libphonenumber-js"), require("moment"));
	else if(typeof define === 'function' && define.amd)
		define("dck-validators", ["email-validator", "libphonenumber-js", "moment"], factory);
	else if(typeof exports === 'object')
		exports["dck-validators"] = factory(require("email-validator"), require("libphonenumber-js"), require("moment"));
	else
		root["dck-validators"] = factory(root["email-validator"], root["libphonenumber-js"], root["moment"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = anything;
/* harmony export (immutable) */ __webpack_exports__["b"] = email;
/* harmony export (immutable) */ __webpack_exports__["c"] = password;
/* harmony export (immutable) */ __webpack_exports__["d"] = passwordConfirmation;
/* harmony export (immutable) */ __webpack_exports__["e"] = requiredValue;
/* harmony export (immutable) */ __webpack_exports__["f"] = date;
/* harmony export (immutable) */ __webpack_exports__["g"] = phoneNumber;
/* harmony export (immutable) */ __webpack_exports__["h"] = gender;
/* harmony export (immutable) */ __webpack_exports__["i"] = float;
/* harmony export (immutable) */ __webpack_exports__["j"] = nonEmpty;
/* harmony export (immutable) */ __webpack_exports__["k"] = regexpValidator;
/* harmony export (immutable) */ __webpack_exports__["l"] = serverSideValidator;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_email_validator__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_email_validator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_email_validator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_libphonenumber_js__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_libphonenumber_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_libphonenumber_js__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);



/**
 * Any value will be valid result.
 * @param {string} value input string
 */
function anything(value) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = true;
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Checks that input string contains email.
 * @param {string} value input string
 */
function email(value, optional) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if ((!value || value.length === 0 || value.trim().length === 0)) {
            empty = true;
            if (optional) {
                valid = true;
            }
        }
        else {
            valid = __WEBPACK_IMPORTED_MODULE_0_email_validator__["validate"](value);
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Password validation, the correct password should contain more than 6 letters.
 * @param {string} value input string
 */
function password(value) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if (!value || value.length < 6) {
            empty = true;
        }
        else {
            valid = true;
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Password confirmation validation, the confirm password should be the same as password.
 * @param {() => string} passwordExtractor password extractor
 */
function passwordConfirmation(passwordExtractor) {
    return function (value) {
        return new Promise(function (resolve, reject) {
            var empty = false;
            var valid = false;
            if (!value) {
                empty = true;
            }
            else {
                var passwordValue = passwordExtractor();
                valid = value === passwordValue;
            }
            resolve({ valid: valid, empty: empty });
        });
    };
}
/**
 * Validator for the required value, the result will be valid if the input string contains any value.
 * @param {string} value input string
 */
function requiredValue(value) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if (!value) {
            empty = true;
        }
        else {
            valid = true;
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Date value validator, the result will be valid if the input string contains date.
 * @param {string} value input string
 */
function date(value, optional) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if ((!value || value.length === 0 || value.trim().length === 0)) {
            empty = true;
            if (optional) {
                valid = true;
            }
        }
        else {
            var dateValue = __WEBPACK_IMPORTED_MODULE_2_moment__(value, "M/D/YYYY", true);
            valid = dateValue.isValid();
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Phone number validator, the result will be valid if the input string contains phone number.
 * @param {string} value input string
 */
function phoneNumber(value, optional) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if ((!value || value.length === 0 || value.trim().length === 0)) {
            empty = true;
            if (optional) {
                valid = true;
            }
        }
        else {
            var phoneNumberValue = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1_libphonenumber_js__["parse"])(value);
            if (Object.keys(phoneNumberValue).length !== 0) {
                valid = true;
            }
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Gender validator, the result will be valid if the input string contains gender(MALE or FEMALE).
 * @param {string} value input string
 */
function gender(value, optional) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if ((!value || value.trim().length === 0)) {
            empty = true;
            if (optional) {
                valid = true;
            }
        }
        else if (value === "MALE" || value === "FEMALE") {
            valid = true;
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Float validator, the result will be valid if the input string contains float value.
 * @param {string} value input string
 */
function float(value, optional) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if ((!value || value.trim().length === 0)) {
            empty = true;
            if (optional) {
                valid = true;
            }
        }
        else {
            if (isFloat(value)) {
                valid = true;
            }
        }
        resolve({ valid: valid, empty: empty });
    });
}
function isFloat(n) {
    return parseFloat(n.match(/^-?\d*(\.\d+)?$/)) > 0;
}
/**
 * Non empty validator, the result will be valid if the input string contains non empty.
 * @param {string} value input string
 */
function nonEmpty(value) {
    return new Promise(function (resolve, reject) {
        var empty = false;
        var valid = false;
        if (!value || !String(value).trim()) {
            empty = true;
        }
        else {
            valid = true;
        }
        resolve({ valid: valid, empty: empty });
    });
}
/**
 * Regex validator, the result will be valid if the input string match with regex.
 * @param {RegExp} regExp input regexp
 */
function regexpValidator(regExp) {
    return function (value) {
        return new Promise(function (resolve, reject) {
            var empty = false;
            var valid = false;
            if (value === "" || !String(value).trim()) {
                empty = true;
            }
            if (regExp.test(String(value))) {
                valid = true;
            }
            resolve({ valid: valid, empty: empty });
        });
    };
}
/**
 * Server-side validation, input string will be checking on the server.
 * @param {() => Promise<any>} requestGenerator server request
 */
function serverSideValidator(requestGenerator) {
    return new Promise(function (resolve, reject) {
        requestGenerator()
            .then(function () {
            var empty = false;
            var valid = true;
            resolve({ valid: valid, empty: empty });
        })
            .catch(function () {
            var empty = false;
            var valid = false;
            resolve({ valid: valid, empty: empty });
        });
    });
}


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__validators__ = __webpack_require__(0);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "anything", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["a"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "email", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["b"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "password", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["c"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "passwordConfirmation", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["d"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "requiredValue", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["e"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "date", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["f"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "phoneNumber", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["g"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "gender", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["h"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "float", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["i"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "nonEmpty", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["j"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "regexpValidator", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["k"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "serverSideValidator", function() { return __WEBPACK_IMPORTED_MODULE_0__validators__["l"]; });
/**
 * @module dck-validators
 */



/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("email-validator");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("libphonenumber-js");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("moment");

/***/ })
/******/ ]);
});
//# sourceMappingURL=dck-validators.js.map